package com.gxwebsoft.oa.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.oa.mapper.OaTaskCountMapper;
import com.gxwebsoft.oa.service.OaTaskCountService;
import com.gxwebsoft.oa.entity.OaTaskCount;
import com.gxwebsoft.oa.param.OaTaskCountParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 数据统计Service实现
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Service
public class OaTaskCountServiceImpl extends ServiceImpl<OaTaskCountMapper, OaTaskCount> implements OaTaskCountService {

    @Override
    public PageResult<OaTaskCount> pageRel(OaTaskCountParam param) {
        PageParam<OaTaskCount, OaTaskCountParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        List<OaTaskCount> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<OaTaskCount> listRel(OaTaskCountParam param) {
        List<OaTaskCount> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<OaTaskCount, OaTaskCountParam> page = new PageParam<>();
        page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public OaTaskCount getByIdRel(Integer taskCountId) {
        OaTaskCountParam param = new OaTaskCountParam();
        param.setTaskCountId(taskCountId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
